=== debian/changelog ===
libiio (0.23-2) unstable; urgency=medium

  * update to v0.23-26-gfbf5adb2

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 27 Nov 2021 19:41:07 -0500

libiio (0.23-1) experimental; urgency=medium

  * New upstream release
  * update to v0.23-19-g4e574547

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 09 Nov 2021 21:56:32 -0500
