## libiio 0.24

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,14 +7,14 @@
 endif()
 
 set(LIBIIO_VERSION_MAJOR 0)
-set(LIBIIO_VERSION_MINOR 23)
+set(LIBIIO_VERSION_MINOR 24)
 set(VERSION "${LIBIIO_VERSION_MAJOR}.${LIBIIO_VERSION_MINOR}")
 if (WIN32)
 	string(TIMESTAMP BUILD_YEAR "%Y")
 endif()
 
 # Set the default install path to /usr
-if (NOT WIN32 AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
+if (NOT APPLE AND NOT WIN32 AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
 	set(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "default install path" FORCE)
 endif()
 
@@ -43,7 +43,8 @@
 	add_definitions(-DLIBIIO_STATIC=1)
 endif()
 
-if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
+option(OSX_FRAMEWORK "Create a OSX_FRAMEWORK" ON)
+if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin" AND OSX_FRAMEWORK)
 	option(OSX_PACKAGE "Create a OSX package" ON)
 
 	set(OSX_INSTALL_FRAMEWORKSDIR "/Library/Frameworks" CACHE STRING "Installation directory for frameworks")
@@ -67,7 +68,9 @@
 endif()
 
 if (MSVC)
-	add_compile_options(/W4 /wd4200 /wd4127 /wd4100)
+	add_compile_options(/Zi /W4 /wd4200 /wd4127 /wd4100)
+	# Zi produces a separate PDB file that contains all the symbolic debugging information
+	# W4 displays level 1, 2, 3, and 4 (informational) warnings that aren't off by default
 	# C4200: nonstandard extension used : zero-sized array in struct (usb.h)
 	# C4127: conditional expression is constant (IIO_ERROR and IIO_DEBUG macros)
 	# C4100: unreferenced parameter; same as -Wno-unused-parameter
@@ -130,11 +133,16 @@
 check_symbol_exists(strdup "string.h" HAS_STRDUP)
 check_symbol_exists(strndup "string.h" HAS_STRNDUP)
 check_symbol_exists(strerror_r "string.h" HAS_STRERROR_R)
+check_symbol_exists(strtok_r "string.h" HAS_STRTOK_R)
 check_symbol_exists(newlocale "locale.h" HAS_NEWLOCALE)
 
 option(ENABLE_IPV6 "Define if you want to enable IPv6 support" ON)
 if (ENABLE_IPV6)
-	check_symbol_exists(in6addr_any "netinet/in.h" HAVE_IPV6)
+	if (WIN32)
+		set(HAVE_IPV6 ON)
+	else()
+		check_symbol_exists(in6addr_any "netinet/in.h" HAVE_IPV6)
+	endif()
 	if (NOT HAVE_IPV6)
 		message(SEND_ERROR "IPv6 is not available in your system.")
 	endif()
@@ -142,15 +150,22 @@
 
 option(WITH_USB_BACKEND "Enable the libusb backend" ON)
 if (WITH_USB_BACKEND)
-	#Handle FreeBSD libusb and Linux libusb-1.0 libraries
-	find_library(LIBUSB_LIBRARIES NAMES usb-1.0 usb)
+	find_package(PkgConfig)
+	if (PkgConfig_FOUND)
+		pkg_check_modules(LIBUSB libusb-1.0)
+		if (NOT LIBUSB_FOUND)
+			#Handle FreeBSD libusb and Linux libusb-1.0 libraries
+			find_library(LIBUSB_LIBRARIES NAMES usb-1.0 usb)
+		else()
+			set(LIBUSB_LIBRARIES ${LIBUSB_LINK_LIBRARIES})
+		endif()
+	endif()
 	find_path(LIBUSB_INCLUDE_DIR libusb.h PATH_SUFFIXES libusb-1.0)
 	if (NOT LIBUSB_LIBRARIES OR NOT LIBUSB_INCLUDE_DIR)
 		message(SEND_ERROR "Unable to find libusb-1.0 dependency.\n"
 			"If you want to disable the USB backend, set WITH_USB_BACKEND=OFF.")
 	else()
-		message(STATUS "Looking for libusb-1.0 : Found")
-
+		list(APPEND LIBIIO_SCAN_BACKENDS usb)
 		set(IIOD_CLIENT 1)
 		set(NEED_LIBXML2 1)
 		set(NEED_THREADS 1)
@@ -170,8 +185,12 @@
 # make sure all check_symbol_exists are before this point, otherwise they fail
 # on some versions of compilers
 if (MSVC)
-	if(DEFINED ENV{CI} AND DEFINED ENV{APPVEYOR})
-		message(STATUS "Running in an AppVeyor environment, setting -Werror")
+	# why can't different CIs use the same flags?
+	# Travis CI      : CI=True & TRAVIS=True
+	# Appveyor       : CI=True & APPVEYOR=True
+	# Azure Pipelines: TF_BUILD=True
+	if(DEFINED ENV{TF_BUILD} OR (DEFINED ENV{CI} AND DEFINED ENV{APPVEYOR}))
+		message(STATUS "Running in an Azure or AppVeyor environment, setting -Werror")
 		add_compile_options(/WX)
 	endif()
 elseif (CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID STREQUAL "Clang")
@@ -181,10 +200,13 @@
 		SET(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage")
 		SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS}  -fprofile-arcs -ftest-coverage")
 	endif()
-	if(DEFINED ENV{CI} AND (DEFINED ENV{TRAVIS} OR DEFINED ENV{APPVEYOR}))
-		message(STATUS "Running in CI environment (Travis or AppVeyor), setting -Werror")
+	if(DEFINED ENV{TF_BUILD} OR (DEFINED ENV{CI} AND (DEFINED ENV{TRAVIS} OR DEFINED ENV{APPVEYOR})))
+		message(STATUS "Running in CI environment (Azure, Travis or AppVeyor), setting -Werror")
 		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")
 	endif()
+else()
+	message(STATUS "Unknown compiler ${CMAKE_C_COMPILER_ID}")
+	message(STATUS "GCC ${CMAKE_COMPILER_IS_GNUCC}")
 endif()
 
 IF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
@@ -246,8 +268,13 @@
 
 	option(WITH_LOCAL_CONFIG "Read local context attributes from /etc/libiio.ini" ON)
 	if (WITH_LOCAL_CONFIG)
-		list(APPEND LIBIIO_CFILES ./libini/libini.c)
-	endif()
+		list(APPEND LIBIIO_CFILES ./deps/libini/libini.c)
+	endif()
+
+	option(WITH_LOCAL_MMAP_API "Use the mmap API provided in Analog Devices' kernel (not upstream)" ON)
+	option(WITH_HWMON "Add compatibility with the hardware monitoring (hwmon) subsystem" OFF)
+
+	list(APPEND LIBIIO_SCAN_BACKENDS local)
 endif()
 
 option(WITH_SERIAL_BACKEND "Enable the serial backend" OFF)
@@ -293,15 +320,15 @@
 include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
 
 if(WITH_NETWORK_BACKEND)
-	message(STATUS "Building with Network back end support")
 	if (WIN32)
 		list(APPEND LIBS_TO_LINK wsock32 iphlpapi ws2_32)
 	endif()
 
 	if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
+		include(CheckCSourceCompiles)
+
 		option(WITH_NETWORK_GET_BUFFER "Enable experimental zero-copy transfers" OFF)
 		if (WITH_NETWORK_GET_BUFFER)
-			include(CheckCSourceCompiles)
 			check_c_source_compiles("#define _GNU_SOURCE=1\n#include <fcntl.h>\nint main(void) { return O_TMPFILE; }"
 				HAS_O_TMPFILE)
 
@@ -310,35 +337,3 @@
 			endif()
 		endif()
 
-		check_c_source_compiles("#include <sys/eventfd.h>\nint main(void) { return eventfd(0, EFD_CLOEXEC | EFD_NONBLOCK); }"
-			WITH_NETWORK_EVENTFD)
-		if (NOT WITH_NETWORK_EVENTFD)
-			check_c_source_compiles("#define _GNU_SOURCE=1\n#include <unistd.h>\n#include <fcntl.h>\nint main(void) { int fd[2]; return pipe2(fd, O_CLOEXEC | O_NONBLOCK); }"
-				HAS_PIPE2)
-		endif()
-
-		if (WITH_NETWORK_GET_BUFFER OR HAS_PIPE2)
-			add_definitions(-D_GNU_SOURCE=1)
-		endif()
-	endif()
-
-	list(APPEND LIBIIO_CFILES network.c)
-	if (WIN32)
-		list(APPEND LIBIIO_CFILES network-windows.c)
-	else()
-		list(APPEND LIBIIO_CFILES network-unix.c)
-	endif()
-
-	option(HAVE_DNS_SD "Enable DNS-SD (ZeroConf) support" ON)
-	if (NOT HAVE_DNS_SD)
-		message(STATUS "Building without DNS-SD (ZeroConf) support")
-	elseif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
-		find_library(CORE_SERVICES CoreServices)
-
-		message(STATUS "Building with CFNetServices, an Apple DNS SD implementation")
-
-		list(APPEND LIBIIO_CFILES dns_sd_bonjour.c dns_sd.c)
-		list(APPEND LIBS_TO_LINK ${CORE_SERVICES} )
-
-	elseif(WIN32)
-		list(APPEND LIBIIO_CFILES dns_sd_windows.c dns_sd.c)
