=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -69,7 +69,10 @@
     set(TEMP1 ${CMAKE_REQUIRED_INCLUDES})
     list(APPEND CMAKE_REQUIRED_LIBRARIES ${CURSES_LIBRARY} ${CDK_LIBRARY})
     list(APPEND CMAKE_REQUIRED_INCLUDES ${LIBCKD_INCLUDE_DIR})
+    set(TMP_FLAGS "${CMAKE_C_FLAGS}")
+    set(CMAKE_C_FLAGS "")
     check_symbol_exists(CDK_CSTRING2 "cdk.h" HAS_CDK_CSTRING2)
+    set(CMAKE_C_FLAGS "${TMP_FLAGS}")
     set(CMAKE_REQUIRED_LIBRARIES ${TEMP})
     set(CMAKE_REQUIRED_INCLUDES ${TEMP1})
 endif()
