=== iiod/CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,10 @@
 include(CheckSymbolExists)
 set(CMAKE_REQUIRED_LIBRARIES ${PTHREAD_LIBRARIES})
 set(CMAKE_REQUIRED_DEFINITIONS -D_GNU_SOURCE)
+set(TMP_FLAGS "${CMAKE_C_FLAGS}")
+set(CMAKE_C_FLAGS "")
 check_symbol_exists(pthread_setname_np "pthread.h" HAS_PTHREAD_SETNAME_NP)
+set(CMAKE_C_FLAGS "${TMP_FLAGS}")
 set(CMAKE_REQUIRED_LIBRARIES)
 set(CMAKE_REQUIRED_DEFINITIONS)
 
@@ -37,8 +40,6 @@
 			"If you want to disable async. I/O support, set WITH_AIO=OFF.")
 	endif ()
 
-	message(STATUS "Looking for libaio: Found")
-
 	option(WITH_IIOD_USBD "Add support for USB through FunctionFS within IIOD" ON)
 	if (WITH_IIOD_USBD)
 		include(CheckTypeSize)
@@ -53,6 +54,11 @@
 
 		set(IIOD_CFILES ${IIOD_CFILES} usbd.c)
 	endif()
+endif()
+
+option(WITH_IIOD_SERIAL "Add serial (UART) support" ON)
+if (WITH_IIOD_SERIAL)
+	set(IIOD_CFILES ${IIOD_CFILES} serial.c)
 endif()
 
 add_executable(iiod ${IIOD_CFILES})
@@ -99,3 +105,13 @@
 	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/init/iiod.conf.cmakein ${PROJECT_BINARY_DIR}/init/iiod.conf)
 	install(FILES ${PROJECT_BINARY_DIR}/init/iiod.conf DESTINATION ${UPSTART_CONF_INSTALL_DIR})
 endif()
+
+list(APPEND IIOD_FEATURES_${WITH_IIOD_SERIAL} iiod-serial)
+list(APPEND IIOD_FEATURES_${WITH_AIO} iiod-aio)
+list(APPEND IIOD_FEATURES_${WITH_IIOD_USBD} iiod-usb)
+list(APPEND IIOD_FEATURES_${WITH_SYSTEMD} iiod-systemd)
+list(APPEND IIOD_FEATURES_${WITH_SYSVINIT} iiod-sysvinit)
+list(APPEND IIOD_FEATURES_${WITH_UPSTART} iiod-upstart)
+
+set(IIOD_FEATURES_ON "${IIOD_FEATURES_ON}" PARENT_SCOPE)
+set(IIOD_FEATURES_OFF "${IIOD_FEATURES_OFF}" PARENT_SCOPE)
