=== man/CMakeLists.txt ===
--- 
+++ 
@@ -59,5 +59,10 @@
 	install(DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_MANDIR}
 		DESTINATION ${CMAKE_INSTALL_MANDIR}/man1
 		COMPONENT doc FILES_MATCHING PATTERN "*.1*")
+endif()
 
-endif()
+list(APPEND IIOM_FEATURES_${WITH_MAN} man)
+list(APPEND IIOM_FEATURES_${WITH_TESTS} man-utils)
+
+set(IIOM_FEATURES_ON "${IIOM_FEATURES_ON}" PARENT_SCOPE)
+set(IIOM_FEATURES_OFF "${IIOM_FEATURES_OFF}" PARENT_SCOPE)
