=== debian/changelog ===
libiio (0.24-4) unstable; urgency=medium

  [ A. Maitland Bottoms ]
  * install the right iiod.service file for iiod
  * edit previous changelog entry for correctness
  * Include the following Debian Janitor improvements from salsa.
  
  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Fix day-of-week for changelog entry 0.6.

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 23 Jan 2023 21:16:11 -0500

libiio (0.24-3) unstable; urgency=medium

  * fix python-libiio.install (Closes: #1021086)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 21 Jan 2023 17:37:55 -0400

libiio (0.24-2) unstable; urgency=medium

  * update python install (Closes: #1020104)

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 21 Sep 2022 23:10:28 -0400

libiio (0.24-1) unstable; urgency=medium

  * New upstream release

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 10 Jul 2022 12:23:05 -0400
